
# Servico HTTP (APACHE)

# Parte comum da instalação da "aplicação" do Expresso para todos os SOs.
# Parametro 1: diretório destino para onde os arquivos do Expresso serão copiados.
cpexpresso ()
{
	DIR_EXPRESSO="$1/expresso"
	# Copia o Expresso para o diretório indicado como parâmetro
	echo "Copiando arquivos do Expresso Livre..."
	cp -r `dirname $PWD` $DIR_EXPRESSO
	# Copia o mkntpwd para o home do Expresso
	mkdir -p /home/expressolivre
	cp $ARQS/home/expressolivre/* /home/expressolivre/
	
	# Requisita a senha
	get_pass
	HEADER_PWD=`php $ARQS/scripts/pass.php $LDAP_PWD`
	sed -e "s/HEADER_PWD/$HEADER_PWD/g" -e "s|EXPRESSO_DIR|$DIR_EXPRESSO|g" $ARQS/header.inc.php > $DIR_EXPRESSO/header.inc.php
	chmod 640 $DIR_EXPRESSO/header.inc.php
	
	# Requisita o domino para corrigir o hosts do servidor, utilizado pelo apache
	get_org
	# Faz backup do hosts
	cp -f /etc/hosts /etc/hosts.`date "+%s"`
	NOVOHOSTS=`mktemp`
	echo "127.0.0.1 $DOMAIN localhost `hostname`" > $NOVOHOSTS
	cat /etc/hosts >> $NOVOHOSTS
	mv -f $NOVOHOSTS /etc/hosts
}

http_debian ()
{
	# Instala o apache2 juntamente com o PHP5 e seus respectivos módulos
	apt-get install -y apache2-mpm-prefork libapache2-mod-php5 apache2-utils \
		php5 php5-common php5-dev php5-gd php5-imap php5-ldap php5-pgsql php5-cgi php5-cli php5-xmlrpc php5-memcache\
		zip unzip
	# Copia os arquivos do Expresso Livre
	cpexpresso "/var/www"
	chown -R www-data:www-data /var/www/expresso /home/expressolivre

	# descomente para gerar o certificado para o https
	#apache2-ssl-certificate;
	a2enmod rewrite
	a2enmod ssl
}

http_debian-squeeze ()
{
	http_debian
	# Copia a configuração do servidor apache2
	cp -a debian/squeeze/etc/apache2/apache2.conf /etc/apache2/
	cp -a debian/squeeze/etc/apache2/ports.conf /etc/apache2/
	cp -a debian/squeeze/etc/apache2/sites-available/expresso /etc/apache2/sites-available/
	cp -a debian/squeeze/etc/apache2/ssl/ /etc/apache2/

	a2ensite expresso
	a2dissite default

	# Copia a configuração do PHP
	#cp -a debian/squeeze/etc/php5/apache2/php.ini /etc/php5/apache2/

	/etc/init.d/apache2 restart
}

http_ubuntu-11.10 ()
{
	http_debian-squeeze
	cp -a ubuntu/11.10/.htaccess $DIR_EXPRESSO
        cp -a ubuntu/11.10/etc/apache2/apache2.conf /etc/apache2/

	/etc/init.d/apache2 restart
}

http_rhel ()
{
	yum -y install httpd mod_ssl \
		php php-cli php-ldap php-pgsql php-imap php-mbstring php-gd php-xml \
		memcached php-pecl-memcache libmemcached \
		unzip zip

	cpexpresso "/var/www/html"
	chown -R apache:apache /var/www/html/expresso /home/expressolivre

	chkconfig httpd on
}

http_rhel6 ()
{
	http_rhel
	# Para pegar ou definir o DOMAIN
	get_org

	cp -a rhel/6/etc/httpd/conf/httpd.conf /etc/httpd/conf/
	sed -e "s/DOMAIN/$DOMAIN/g" rhel/6/etc/httpd/conf.d/expresso.conf > /etc/httpd/conf.d/expresso.conf
	cp -a rhel/6/etc/httpd/conf.d/ssl.conf /etc/httpd/conf.d/

	service httpd restart
}

#
# TODO: Preciso de alguem que ajude a testar o SLES! Nao garanto que este codigo funcione
#
http_sles ()
{
	yast -i apache2 apache2-prefork apache2-mod_php5 \
		php5 php5-devel php5-gd php5-imap php5-ldap php5-pgsql php5-mbstring php5-pear-auth \
		zip unzip

	cpexpresso "/srv/www/htdocs"
	chown -R wwwrun:www /srv/www/htdocs/expresso /home/expressolivre

	a2enmod rewrite
}

http_sles10 ()
{
	http_sles

	cp -a sles10/etc/apache2/httpd.conf /etc/apache2/
	cp -a sles10/etc/apache2/server-tuning.conf /etc/apache2/
	cp -a sles10/etc/apache2/vhosts.d/expresso.conf /etc/apache2/vhosts.d/
	cp -a sles10/etc/apache2/sysconfig.d/global.conf /etc/apache2/sysconfig.d/
	cp -a sles10/etc/php5/apache2/php.ini /etc/php5/apache2/

	rcapache2 restart
}
